#!/usr/bin/perl

$fmesh="wae.mesh";

$PI=3.14159;

$jend=0;
$jstart=-200;
$dj=5;

$yscale = $jend - $jstart;

$istart=0;
$iend=200;
$di=5;

$m = 2;
$beta = $PI * $m;
$k = 2.0 * $PI / 0.83;
$alpha = sqrt($k * $k - $beta * $beta);

open(IFILE, ">$fmesh") or (print "Error opening $fmesh\n" and die);


for ($j = $jstart; $j <= $jend; $j += $dj) {
    for ($i = $istart; $i <= $iend; $i += $di) {
	$x = $i/100.0 - 1.0;
	$y = $j/$yscale;

	$v = cos($x*$alpha);
	$w = cos($y*$beta);
	$z = $v * $w;

        print {IFILE} sprintf("%.4f %.4f %.4f %.4f %.4f\n", $x,$y,$z,$v,$w);
    }
    print  {IFILE}  "\n";
}

