#!/usr/bin/perl

$PI=3.14159;

$iend=180;
$wscale=2.0*$PI/$iend;

$r0=0.15;
$r1=1.0;

# -- 1. --

$fmesh="dipo.dat";

$jend=80;

$lambda=0.6;
$k=2.0*$PI/$lambda;

$rscale=($r1-$r0)/$jend;
$dr=-0.22;

open(IFILE, ">$fmesh") or (print "Error opening $fmesh\n" and die);


for ($j = 0; $j <= $jend; $j++) {
    for ($i = 0; $i <= $iend; $i++) {
	$w = $i*$wscale;
	$cw = cos($w);
	$sw = sin($w);

	$r = $j*$rscale + $r0;

	$x = $cw * $r;
	$y = $sw * $r;
	$z = $cw*(cos($k*($r+$dr))/($r*$r)-2.0*$PI*sin($k*($r+$dr))/$r);

	print  {IFILE} sprintf("%.4f %.4f %.4f\n", $x,$y,$z);
    }
    print  {IFILE}  "\n";
}

close IFILE;

# -- 2. --

$smesh="tube.dat";

$jend=20;

$z0=-1.0;
$z1=1.0;
$zscale=($z1-$z0)/$jend;

open(BFILE, ">$smesh") or (print "Error opening $smesh\n" and die);

for ($j = 0; $j <= $jend; $j++) {
    for ($i = 0; $i <= $iend; $i++) {
	$w = $i*$wscale;
	$cw = cos($w);
	$sw = sin($w);

	$x = $cw * $r0;
	$y = $sw * $r0;
	$z = $j*$zscale + $z0;

	print {BFILE} sprintf("%.4f %.4f %.4f\n", $x,$y,$z);
    }
    print  {BFILE}  "\n";
}

close BFILE;
